const Express = require("express")();
const Http = require("http").Server(Express);
const Socketio = require("socket.io")(Http);

Http.listen(3000, () => {
    console.log("Listening at :3000...");
});

var position = {
    x: 200,
    y: 200
};

var currentCard = {};
var newRound = {};
var endRound = {};

Socketio.on("connection", socket => {
    console.log('new Socket connect');
    socket.emit("position", position);
    socket.on("move", data => {
        console.log('Data: ', data);
        switch(data) {
            case "left":
                console.log('left');
                position.x -= 5;
                Socketio.emit("position", position);
                break;
            case "right":
                position.x += 5;
                Socketio.emit("position", position);
                break;
            case "up":
                position.y -= 5;
                Socketio.emit("position", position);
                break;
            case "down":
                position.y += 5;
                Socketio.emit("position", position);
                break;
        }
    });

    for (var key in currentCard) {
        socket.emit(key, currentCard[key])
    }
    /*for (var key in newRound) {
        socket.emit(key, newRound[key])
    }
    for (var key in endRound) {
        socket.emit(key, endRound[key])
    }*/
    socket.on("newCard", data => {
        console.log('New Card from: ', data, ':newCard');
        currentCard[data.sessionName+":newCard"] = data.cardID;
        Socketio.emit(data.sessionName+":newCard", data.cardID)
    });
    socket.on("newRound", data => {
        console.log('New Round from: ', data.isOpen);
        endRound[data.sessionName+":endRound"] = false;
        Socketio.emit(data.sessionName+":endRound", false);
        socket.emit(data.sessionName+":endRound", false);
        newRound[data.sessionName+":newRound"] = true;
        Socketio.emit(data.sessionName+":newRound", true);
        socket.emit(data.sessionName+":newRound", true);
    });
    socket.on("endRound", data => {
        console.log('End Round from: ', data.isOpen);
        newRound[data.sessionName+":newRound"] = false;
        Socketio.emit(data.sessionName+":newRound", false);
        socket.emit(data.sessionName+":newRound", false);
        endRound[data.sessionName+":endRound"] = true;
        Socketio.emit(data.sessionName+":endRound", true);
        socket.emit(data.sessionName+":endRound", true);
    });
});

